| Version: 3.0.1

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
wxGenericValidator Class Reference
Validators

`#include <wx/valgen.h>`

Inheritance diagram for wxGenericValidator:
[legend]

## Detailed Description

wxGenericValidator performs data transfer (but not validation or filtering) for many type of controls.

wxGenericValidator supports:

- wxButton, wxRadioButton, wxToggleButton, wxBitmapToggleButton, wxSpinButton
- wxCheckBox, wxRadioBox, wxComboBox, wxListBox, wxCheckListBox
- wxGauge, wxSlider, wxScrollBar, wxChoice, wxStaticText
- wxSpinCtrl, wxTextCtrl

It checks the type of the window and uses an appropriate type for it. For example, wxButton and wxTextCtrl transfer data to and from a wxString variable; wxListBox uses a wxArrayInt; wxCheckBox uses a boolean.

For more information, please see wxValidator Overview.

##

Library: wxCore
Category: Validators

See Also
  wxValidator Overview, wxValidator, wxTextValidator, wxIntegerValidator, wxFloatingPointValidator

## Public Member Functions

| wxGenericValidator (const wxGenericValidator &validator)
| Copy constructor.
| wxGenericValidator (bool *valPtr)
| Constructor taking a bool pointer.
| wxGenericValidator (wxString *valPtr)
| Constructor taking a wxString pointer.
| wxGenericValidator (int *valPtr)
| Constructor taking an integer pointer.
| wxGenericValidator (wxArrayInt *valPtr)
| Constructor taking a wxArrayInt pointer.
| wxGenericValidator (wxDateTime *valPtr)
| Constructor taking a wxDateTime pointer.
| wxGenericValidator (wxFileName *valPtr)
| Constructor taking a wxFileName pointer.
| wxGenericValidator (float *valPtr)
| Constructor taking a float pointer.
| wxGenericValidator (double *valPtr)
| Constructor taking a double pointer.
virtual | ~wxGenericValidator ()
| Destructor.
virtual wxObject * | Clone () const
| Clones the generic validator using the copy constructor.
virtual bool | TransferFromWindow ()
| Transfers the value from the window to the appropriate data type.
virtual bool | TransferToWindow ()
| Transfers the value to the window.
Public Member Functions inherited from wxValidator
| wxValidator ()
| Constructor.
virtual | ~wxValidator ()
| Destructor.
wxWindow * | GetWindow () const
| Returns the window associated with the validator.
void | SetWindow (wxWindow *window)
| Associates a window with the validator.
virtual bool | Validate (wxWindow *parent)
| This overridable function is called when the value in the associated window must be validated.
Public Member Functions inherited from wxEvtHandler
| wxEvtHandler ()
| Constructor.
virtual | ~wxEvtHandler ()
| Destructor.
virtual void | QueueEvent (wxEvent *event)
| Queue event for a later processing.
virtual void | AddPendingEvent (const wxEvent &event)
| Post an event to be processed later.
template<typename T , typename T1 , ... >
void | CallAfter (void(T::*method)(T1,...), T1 x1,...)
| Asynchronously call the given method.
template<typename T >
void | CallAfter (const T &functor)
| Asynchronously call the given functor.
virtual bool | ProcessEvent (wxEvent &event)
| Processes an event, searching event tables and calling zero or more suitable event handler function(s).
bool | ProcessEventLocally (wxEvent &event)
| Try to process the event in this handler and all those chained to it.
bool | SafelyProcessEvent (wxEvent &event)
| Processes an event by calling ProcessEvent() and handles any exceptions that occur in the process.
void | ProcessPendingEvents ()
| Processes the pending events previously queued using QueueEvent() or AddPendingEvent(); you must call this function only if you are sure there are pending events for this handler, otherwise a `wxCHECK` will fail.
void | DeletePendingEvents ()
| Deletes all events queued on this event handler using QueueEvent() or AddPendingEvent().
virtual bool | SearchEventTable (wxEventTable &table, wxEvent &event)
| Searches the event table, executing an event handler function if an appropriate one is found.
void | Connect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Connects the given function dynamically with the event handler, id and event type.
void | Connect (int id, wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
void | Connect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Connect(int, int, wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (wxEventType eventType, wxObjectEventFunction function, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| Disconnects the given function dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
bool | Disconnect (int id=wxID_ANY, wxEventType eventType=wxEVT_NULL, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
bool | Disconnect (int id, int lastId, wxEventType eventType, wxObjectEventFunction function=NULL, wxObject *userData=NULL, wxEvtHandler *eventSink=NULL)
| See the Disconnect(wxEventType, wxObjectEventFunction, wxObject*, wxEvtHandler*) overload for more info.
template<typename EventTag , typename Functor >
void | Bind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Binds the given function, functor or method dynamically with the event.
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
void | Bind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Bind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
template<typename EventTag , typename Functor >
bool | Unbind (const EventTag &eventType, Functor functor, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| Unbinds the given function, functor or method dynamically from the event handler, using the specified parameters as search criteria and returning true if a matching function has been found and removed.
template<typename EventTag , typename Class , typename EventArg , typename EventHandler >
bool | Unbind (const EventTag &eventType, void(Class::*method)(EventArg &), EventHandler *handler, int id=wxID_ANY, int lastId=wxID_ANY, wxObject *userData=NULL)
| See the Unbind<>(const EventTag&, Functor, int, int, wxObject*) overload for more info.
void * | GetClientData () const
| Returns user-supplied client data.
wxClientData * | GetClientObject () const
| Returns a pointer to the user-supplied client data object.
void | SetClientData (void *data)
| Sets user-supplied client data.
void | SetClientObject (wxClientData *data)
| Set the client data object.
bool | GetEvtHandlerEnabled () const
| Returns true if the event handler is enabled, false otherwise.
wxEvtHandler * | GetNextHandler () const
| Returns the pointer to the next handler in the chain.
wxEvtHandler * | GetPreviousHandler () const
| Returns the pointer to the previous handler in the chain.
void | SetEvtHandlerEnabled (bool enabled)
| Enables or disables the event handler.
virtual void | SetNextHandler (wxEvtHandler *handler)
| Sets the pointer to the next handler.
virtual void | SetPreviousHandler (wxEvtHandler *handler)
| Sets the pointer to the previous handler.
void | Unlink ()
| Unlinks this event handler from the chain it's part of (if any); then links the "previous" event handler to the "next" one (so that the chain won't be interrupted).
bool | IsUnlinked () const
| Returns true if the next and the previous handler pointers of this event handler instance are NULL.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Additional Inherited Members

Static Public Member Functions inherited from wxValidator
static void | SuppressBellOnError (bool suppress=true)
| This functions switches on or turns off the error sound produced by the validators if an invalid key is pressed.
static bool | IsSilent ()
| Returns if the error sound is currently disabled.
Protected Member Functions inherited from wxEvtHandler
virtual bool | TryBefore (wxEvent &event)
| Method called by ProcessEvent() before examining this object event tables.
virtual bool | TryAfter (wxEvent &event)
| Method called by ProcessEvent() as last resort.
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data.

## Constructor & Destructor Documentation

wxGenericValidator::wxGenericValidator | ( | const wxGenericValidator & | validator | ) |

Copy constructor.

Parameters

  validator | Validator to copy.

wxGenericValidator::wxGenericValidator | ( | bool * | valPtr | ) |

Constructor taking a bool pointer.

This will be used for wxCheckBox, wxRadioButton, wxToggleButton and wxBitmapToggleButton.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

wxGenericValidator::wxGenericValidator | ( | wxString * | valPtr | ) |

Constructor taking a wxString pointer.

This will be used for wxButton, wxComboBox, wxStaticText, wxTextCtrl.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

wxGenericValidator::wxGenericValidator | ( | int * | valPtr | ) |

Constructor taking an integer pointer.

This will be used for wxChoice, wxGauge, wxScrollBar, wxRadioBox, wxSlider, wxSpinButton and wxSpinCtrl.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

wxGenericValidator::wxGenericValidator | ( | wxArrayInt * | valPtr | ) |

Constructor taking a wxArrayInt pointer.

This will be used for wxListBox, wxCheckListBox.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

wxGenericValidator::wxGenericValidator | ( | wxDateTime * | valPtr | ) |

Constructor taking a wxDateTime pointer.

This will be used for wxDatePickerCtrl.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

wxGenericValidator::wxGenericValidator | ( | wxFileName * | valPtr | ) |

Constructor taking a wxFileName pointer.

This will be used for wxTextCtrl.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

Since
  2.9.3

wxGenericValidator::wxGenericValidator | ( | float * | valPtr | ) |

Constructor taking a float pointer.

This will be used for wxTextCtrl.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

Since
  2.9.3

wxGenericValidator::wxGenericValidator | ( | double * | valPtr | ) |

Constructor taking a double pointer.

This will be used for wxTextCtrl.

Parameters

  valPtr | A pointer to a variable that contains the value. This variable should have a lifetime equal to or longer than the validator lifetime (which is usually determined by the lifetime of the window).

Since
  2.9.3

virtual wxGenericValidator::~wxGenericValidator | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

virtual wxObject* wxGenericValidator::Clone | ( |  | ) | const

virtual

Clones the generic validator using the copy constructor.

Reimplemented from wxValidator.

virtual bool wxGenericValidator::TransferFromWindow | ( |  | ) |

virtual

Transfers the value from the window to the appropriate data type.

Reimplemented from wxValidator.

virtual bool wxGenericValidator::TransferToWindow | ( |  | ) |

virtual

Transfers the value to the window.

Reimplemented from wxValidator.